package models

import (
	"github.com/beego/beego/v2/client/orm"
	"hongze/hongze_cygx/utils"
	"time"
)

// ActivityVoice 活动语音表结构体
type CygxActivityVoice struct {
	ActivityVoiceId  int       `orm:"column(activity_voice_id);pk" description:"活动音频ID"`
	ActivityId       int       ` description:"活动ID"`
	VoiceUrl         string    `description:"音频地址"`
	VoiceName        string    `description:"音频名称"`
	VoicePlaySeconds string    `description:"音频时长"`
	CreateTime       time.Time `description:"创建时间"`
}

// ActivityVoiceReq 音频数据
type CygxActivityVoiceReq struct {
	ActivityId  int    ` description:"活动ID"`
	Url         string `description:"音频资源url地址"`
	Name        string `description:"音频名称"`
	PlaySeconds int    `description:"音频时长"`
}

// GetCygxActivityVoiceReqList 获取活动ID的音频
func GetCygxActivityVoiceReqList(activityIds []int) (items []*CygxActivityVoiceReq, err error) {
	lenactivityIds := len(activityIds)
	if lenactivityIds == 0 {
		return
	}
	sql := `SELECT 
			activity_id ,
			voice_url AS url,
			voice_name AS name,
			voice_play_seconds AS play_seconds  FROM cygx_activity_voice  WHERE activity_id IN (` + utils.GetOrmInReplace(lenactivityIds) + `)  `
	o := orm.NewOrm()
	_, err = o.Raw(sql, activityIds).QueryRows(&items)
	return
}
