package services

import (
	"context"
	"fmt"
	"hongze/hongze_cygx/models"
	"hongze/hongze_cygx/utils"
	"strings"
)

//修改标签状态
func UpdateIndustrialManagementLabel(cont context.Context) (err error) {
	defer func() {
		if err != nil {
			fmt.Println("修改失败，Err:", err.Error())
		}
	}()
	fmt.Println("修改状态0000")
	go models.UpdateIndustrialIsNewLabel()

	list, err := models.GetIndustrialMorethan10()
	if err != nil {
		return err
	}
	if len(list) == 0 {
		return
	}
	var idStr string
	for _, v := range list {
		idStr += v.IndustrialManagementId + ","
	}
	idStr = strings.TrimRight(idStr, ",")

	go models.UpdateIndustrialIsDeepLabel(idStr)
	//fmt.Println(idStr)
	//go models.UpdateActivitySattusToComplete()
	fmt.Println("修改状态完成")
	return
}

//修改活动状态
func UpdateIndustrialManagementSubjectNnames() (err error) {
	defer func() {
		if err != nil {
			fmt.Println("修改失败，Err:", err.Error())
		}
	}()
	fmt.Println("修改产业关联标的")
	list, err := models.GetIndustrialManagementIds()
	if err != nil {
		return err
	}
	for _, v := range list {
		//fmt.Println(v.IndustrialManagementId)
		var nameSub string
		listSub, errdSub := models.GetcygxIndustrialSubject(v.IndustrialManagementId)
		if errdSub != nil {
			return errdSub
		}
		for _, v2 := range listSub {
			fmt.Println(v2.SubjectName)
			nameSub += v2.SubjectName + ","
		}
		nameSub += v.IndustryName
		go models.UpdateIndustrialManagementSubjectNames(nameSub, v.IndustrialManagementId)

	}
	if len(list) == 0 {
		return
	}

	fmt.Println("修改状态完成")
	return
}

func ChageIndustrialArticleNum(cont context.Context) (err error) {
	allList, err := models.IndustrialManagementAll()
	if err != nil {
		fmt.Println("GetArticleAll Err:", err.Error())
		return
	}
	for _, v := range allList {
		total, errTop := models.GetIndustrialManagementArtCount(v.IndustrialManagementId)
		if errTop != nil {
			fmt.Println("Top Err:", errTop.Error())
			return
		}
		if total > 0 {
			err = models.UpdateIndustrialManagementArtReadNum(total, v.IndustrialManagementId)
			if err != nil {
				fmt.Println("Update Err:", err.Error())
				return
			}
		}
	}
	return
}

func ReportBillboardUpdate(cont context.Context) (err error) {
	//修改产业关注数量
	go IndustryFllowCountUpdate()

	//修改文章收藏数量
	go ArticleCollectCountUpdate()
	return
}

//修改产业关注数量
func IndustryFllowCountUpdate() (err error) {
	defer func() {
		if err != nil {
			go utils.SendAlarmMsg("修改产业关注数量信息失败"+err.Error(), 2)
			go utils.SendEmail(utils.APPNAME+"【"+utils.RunMode+"】"+"失败提醒", "GetCeLueArticlePv ErrMsg:"+err.Error(), utils.EmailSendToUsers)
		}
	}()
	fllowList, err := models.GetUserFllowIndustrialCountList()
	if err != nil {
		return
	}
	for _, v := range fllowList {
		err = models.UpdateIndustrialManagementFllowNum(v.Num, v.IndustrialManagementId)
		if err != nil {
			return
		}
	}
	return err
}

//修改文章收藏数量
func ArticleCollectCountUpdate() (err error) {
	defer func() {
		if err != nil {
			go utils.SendAlarmMsg("修改文章收藏数量信息失败"+err.Error(), 2)
			go utils.SendEmail(utils.APPNAME+"【"+utils.RunMode+"】"+"失败提醒", "修改文章收藏数量信息失败 ErrMsg:"+err.Error(), utils.EmailSendToUsers)
		}
	}()
	collectList, err := models.GetUserArticleCollectList()
	if err != nil {
		return
	}
	for _, v := range collectList {
		err = models.UpdateArticleCollectCountNum(v.Num, v.ArticleId)
		if err != nil {
			return
		}
	}
	return err
}

//根据行业处理所选的全部赛道字段
func DoXzsChooseSend(chartPermissionName string) string {
	var allIn string
	if chartPermissionName == utils.YI_YAO_NAME {
		allIn = "all_in_yi_yao"
	} else if chartPermissionName == utils.XIAO_FEI_NAME {
		allIn = "all_in_xiao_fei"
	} else if chartPermissionName == utils.KE_JI_NAME {
		allIn = "all_in_ke_ji"
	} else if chartPermissionName == utils.ZHI_ZAO_NAME {
		allIn = "all_in_zhi_zao"
	} else if chartPermissionName == utils.CHART_PERMISSION_NAME_MF_YANXUAN {
		allIn = "all_in_yan_xuan"
	}
	return allIn
}

//行业关注或者取消关注的时候，对于用户全部赛道的影响
func IndustryFllowWithTrack(industrialManagementId, count, uid int) (err error) {
	defer func() {
		if err != nil {
			fmt.Println(err)
			go utils.SendAlarmMsg("修改行业关注或者取消关注的时候，对于用户全部赛道的影响信息失败"+err.Error(), 2)
			go utils.SendEmail(utils.APPNAME+"【"+utils.RunMode+"】"+"失败提醒", "修改行业关注或者取消关注的时候，对于用户全部赛道的影响信息失败 ErrMsg:"+err.Error(), utils.EmailSendToUsers)
		}
	}()
	detail, err := models.GetIndustrialManagementDetail(industrialManagementId)
	if err != nil {
		return err
	}
	categoryinfo, err := models.GetChartPermissionById(detail.ChartPermissionId)
	if err != nil {
		return err
	}
	var allIn string
	allIn = DoXzsChooseSend(categoryinfo.PermissionName)
	if allIn != "" {
		//如果取消关注就把该赛道设置为非全部赛道
		if count == 1 {
			err = models.UpdateCygxXzsChooseSendIsAllIn(allIn, 0, uid)
			if err != nil {
				return err
			}
		} else {
			//医药、消费、科技、智造、研选下的产业赛道
			mapIndustrial := make(map[int][]*models.IndustrialManagementRep)
			industrialList, err := models.GetindustrialManagement()
			if err != nil {
				return err
			}
			for _, v := range industrialList {
				mapIndustrial[v.ChartPermissionId] = append(mapIndustrial[v.ChartPermissionId], v)
			}
			fllowNum, err := models.GetCountCygxIndustryFllowByUidAndChartPermissionId(uid, detail.ChartPermissionId)
			if err != nil {
				return err
			}
			if fllowNum == len(mapIndustrial[detail.ChartPermissionId]) {
				err = models.UpdateCygxXzsChooseSendIsAllIn(allIn, 1, uid)
				if err != nil {
					return err
				}
			}
		}
	}
	return err
}
